{

    Dieses Programm ist freie Software. Sie knnen es unter
    den Bedingungen der GNU General Public License, wie von der
    Free Software Foundation herausgegeben, weitergeben und/oder
    modifizieren, entweder unter Version 2 der Lizenz oder (wenn
    Sie es wnschen) jeder spteren Version

Autor: Thorsten Eggeling
Firma: IDG Magazine GmbH
Email: prx@pcwelt.de
Datum: 09/2005
Version: 1.1.0

Infos: compiliert mit Borland Delphi 7

Zustzliche Freeware/GPL-Komponenten:
Jedi (http://www.delphi-jedi.org)
EasyNSE (http://www.mustangpeak.net/easynse.htm)
}


unit ModalForm;

interface

{$include Compilers.Inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, EasyModalForm,
  StdCtrls,JclSecurity,JclSysInfo,JclWin32, JvExControls, JvComponent,
  JvLinkLabel, janMarkupViewer;

type
  TSampleModalForm = class(TEasyModalForm)
    Button1: TButton;
    Memo1: TMemo;
    janMarkupViewer1: TjanMarkupViewer;
    procedure EasyModalFormShow(Sender: TObject);
    function GetGroups: string;
    function EnumPriv:String;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SampleModalForm: TSampleModalForm;
  isAdmin:Boolean;
const
// 
// Group attributes
//

  SE_GROUP_MANDATORY          = ($00000001);
  {$EXTERNALSYM SE_GROUP_MANDATORY}
  SE_GROUP_ENABLED_BY_DEFAULT = ($00000002);
  {$EXTERNALSYM SE_GROUP_ENABLED_BY_DEFAULT}
  SE_GROUP_ENABLED            = ($00000004);
  {$EXTERNALSYM SE_GROUP_ENABLED}
  SE_GROUP_OWNER              = ($00000008);
  {$EXTERNALSYM SE_GROUP_OWNER}
  SE_GROUP_USE_FOR_DENY_ONLY  = ($00000010);
  {$EXTERNALSYM SE_GROUP_USE_FOR_DENY_ONLY}
  SE_GROUP_LOGON_ID           = ($C0000000);
  {$EXTERNALSYM SE_GROUP_LOGON_ID}
  SE_GROUP_RESOURCE           = ($20000000);
  {$EXTERNALSYM SE_GROUP_RESOURCE}

implementation

{$R *.dfm}

//////////////////////////////////////////////////
function GetCurrentUserAndDomain: String;

var
   fSuccess : boolean;
   hToken   : THandle;
   ptiUser  : PSIDAndAttributes;
   cbti     : DWORD;
   snu      : SID_NAME_USE;

   szUser,
    szDomain     : String;
  pcchUser ,
  pcchDomain : DWORD;

begin
   ptiUser := nil;
   Result := '';
   pcchUser:=0;
   pcchDomain:=0;

   try
      // Get the calling thread's access token.
      if (not OpenThreadToken(GetCurrentThread(), TOKEN_QUERY, TRUE,
            hToken)) then

       begin
         if (GetLastError() <> ERROR_NO_TOKEN) then
            exit;

         // Retry against process token if no thread token exists.
         if (not OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY,
               hToken)) then
            exit;
       end;

      // Obtain the size of the user information in the token.
      if (GetTokenInformation(hToken, TokenUser, nil, 0, cbti)) then

         // Call should have failed due to zero-length buffer.
         Exit

       else

         // Call should have failed due to zero-length buffer.
         if (GetLastError() <> ERROR_INSUFFICIENT_BUFFER) then
            Exit;


      // Allocate buffer for user information in the token.
      ptiUser :=  HeapAlloc(GetProcessHeap(), 0, cbti);
      if (ptiUser= nil) then
         Exit;

      // Retrieve the user information from the token.
      if ( not GetTokenInformation(hToken, TokenUser, ptiUser, cbti, cbti)) then
         Exit;

       LookupAccountSid(nil, ptiUser.Sid, nil, pcchUser, nil, pcchDomain, snu);
       SetLength(szUser, pcchUser);
       SetLength(szDomain, pcchDomain);

      // Retrieve user name and domain name based on user's SID.
      if ( not LookupAccountSid(nil, ptiUser.Sid, PChar(szUser), pcchUser,
            PChar(szDomain), pcchDomain, snu)) then
         Exit;

      fSuccess := TRUE;

   finally

      // Free resources.
      if (hToken > 0) then
         CloseHandle(hToken);

      if (ptiUser <> nil) then
         HeapFree(GetProcessHeap(), 0, ptiUser);
   end;

   Result :=  PChar(szDomain) + '\' + PChar(szUser);
end;
//////////////////////////////////////////////
function SidToStr(Sid : PSID):WideString;
var
 SIA : PSidIdentifierAuthority;
 dwCount : Cardinal;
 I : Integer;
begin
 // S-R-I-S-S...
 Result:='';

 if not isValidSid(Sid) then Exit;

 Result:='S-';
 Result:=Result+IntToStr(Byte(Sid^))+'-';
 sia:=GetSidIdentifierAuthority(Sid);
 Result:=Result+IntToStr(sia.Value[5]); //S-R-I-
 dwCount:= GetSidSubAuthorityCount(Sid)^;

 for i:=0 to dwCount-1 do
  Result:=Result+'-'+IntToStr(GetSidSubAuthority(Sid,i)^);

end;
/////////////////////////////////////////////////
function LookupAccountBySid(Sid: PSID): String;
var
    Name,
    Domain     : String;
    NameSize,
    DomainSize : DWORD;
    Use        : Cardinal;
begin
    NameSize := 0;
    DomainSize := 0;
    LookupAccountSid(nil, Sid, nil, NameSize, nil, DomainSize, Use);
    SetLength(Name, NameSize);
    SetLength(Domain, DomainSize);
    LookupAccountSid(nil, Sid, PChar(Name), NameSize, PChar(Domain), DomainSize, Use);
    Result := PChar(Domain) + '\' + PChar(Name);
end;
////////////////////
function TSampleModalForm.GetGroups: String;
var
  psidAdmin: Pointer;
  Token: THandle;
  Count: DWORD;
  TokenInfo: PTokenGroups;
  HaveToken: Boolean;
  I: Integer;
   Attr: Longword;
  S:String;
   /////////
   function AttrToString: string;
  begin
    Result := '';
    if (Attr and SE_GROUP_MANDATORY) <> 0 then
       Result := Result + ' mandatory ';

       if (Attr and SE_GROUP_ENABLED) <> 0 then
       Result := Result + ' enabled '
       else
       Result := Result + ' disabled ';

     if (Attr and SE_GROUP_ENABLED_BY_DEFAULT) <> 0 then
       Result := Result + ' default ';

       if (Attr and SE_GROUP_OWNER) <> 0 then
       Result := Result + ' can_be_owner ';

       if (Attr and SE_GROUP_LOGON_ID) <> 0 then
       Result := Result + ' logon_SID ';

    Result := '[' + Trim(Result) + ']';
  end;
  //
begin
  if not IsWinNT then  // Win9x/ME
    Exit;
  psidAdmin := nil;
  TokenInfo := nil;
  HaveToken := False;

  try
    HaveToken := OpenThreadToken(GetCurrentThread, TOKEN_QUERY, True, Token);

   if (not HaveToken) and (GetLastError = ERROR_NO_TOKEN) then
    HaveToken := OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, Token);

    if HaveToken then
    begin
      {$IFDEF FPC}

      Win32Check(AllocateAndInitializeSid(SECURITY_NT_AUTHORITY, 2,
        SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0,
        psidAdmin));

      if GetTokenInformation(Token, TokenGroups, nil, 0, @Count) or
       (GetLastError <> ERROR_INSUFFICIENT_BUFFER) then
         RaiseLastOSError;

      TokenInfo := PTokenGroups(AllocMem(Count));
      Win32Check(GetTokenInformation(Token, TokenGroups, TokenInfo, Count, @Count));

      {$ELSE FPC}

      Win32Check(AllocateAndInitializeSid(SECURITY_NT_AUTHORITY, 2,
        SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0,
        psidAdmin));
      if GetTokenInformation(Token, TokenGroups, nil, 0, Count) or
       (GetLastError <> ERROR_INSUFFICIENT_BUFFER) then
         RaiseLastOSError;
      TokenInfo := PTokenGroups(AllocMem(Count));
      Win32Check(GetTokenInformation(Token, TokenGroups, TokenInfo, Count, Count));
      {$ENDIF FPC}

      //ShowMessage(IntToStr(TokenInfo^.GroupCount));
      for I := 0 to TokenInfo^.GroupCount - 1 do
      begin
        {$RANGECHECKS OFF} // Groups is an array [0..0] of TSIDAndAttributes, ignore ERangeError
        //isAdmin?
        If EqualSid(psidAdmin, TokenInfo^.Groups[I].Sid) Then
           isAdmin:=True;
        Attr:=TokenInfo^.Groups[I].Attributes;
        S:=LookupAccountBySid(TokenInfo^.Groups[i].Sid);
        If S='\' Then
        begin
        S:=Format('%-40s %20s',['Logon SID ' + SidToStr(TokenInfo^.Groups[i].Sid),AttrToString]);
        Result:=Result+S +'<br>';
        end
        else
        begin
        S:=Format('%-40s %20s',[LookupAccountBySid(TokenInfo^.Groups[i].Sid),AttrToString]);
        Result:=Result+S+'<br>';

        end;
        {$IFDEF RANGECHECKS_ON}
        {$RANGECHECKS ON}
        {$ENDIF RANGECHECKS_ON}
        //if Result then
        //  Break;
      end;

    end;

  finally
    if TokenInfo <> nil then
      FreeMem(TokenInfo);
    if HaveToken then
      CloseHandle(Token);
    if psidAdmin <> nil then
      FreeSid(psidAdmin);
  end;
end;


function TSampleModalForm.EnumPriv:string;
type
  TPrivilegesArray = array [0..1024] of TLuidAndAttributes;
  PPrivilegesArray = ^TPrivilegesArray;
var
  TokenHandle: THandle;
  Size: Cardinal;
  Privileges: PTokenPrivileges;
  I: Integer;
  Luid: TLargeInteger;
  Name: string;
  Attr: Longword;
function AttrToString: string;
  begin
    Result := '';
    if (Attr and SE_PRIVILEGE_ENABLED) <> 0 then
       Result := Result + 'Enabled ';
    if (Attr and SE_PRIVILEGE_ENABLED_BY_DEFAULT) <> 0
       then Result := Result + 'EnabledByDefault';
    if (Attr and SE_PRIVILEGE_ENABLED) = 0 then
       Result := Result + 'disabled ';
    Result := '[' + Trim(Result) + ']';
  end;
begin
  Win32Check(OpenProcessToken(GetCurrentProcess,
    TOKEN_QUERY, TokenHandle));
  try
    GetTokenInformation(TokenHandle, TokenPrivileges, nil,
      0, Size);
    Privileges := AllocMem(Size);
    Win32Check(GetTokenInformation(TokenHandle,
      TokenPrivileges, Privileges, Size, Size));
    for I := 0 to Privileges.PrivilegeCount - 1 do begin
      Luid := PPrivilegesArray(
        @Privileges^.Privileges)^[I].Luid;
      Attr := PPrivilegesArray(
        @Privileges^.Privileges)^[I].Attributes;
      Size := 0;
      LookupPrivilegeName(nil, Luid, nil, Size);
      SetLength(Name, Size);
      LookupPrivilegeName(nil, Luid, PChar(Name), Size);
      //Memo1.Lines.Add(Format('%-45s %8s',[PChar(Name),AttrToString]));
      Result:=Result+Format('%-40s %8s',[PChar(Name),AttrToString])+'<br>';
      //Memo1.Lines.Add(PChar(Name) + ' ' +
      //  AttrToString);
    end;
  finally
    CloseHandle(TokenHandle);
  end;
end;


procedure TSampleModalForm.EasyModalFormShow(Sender: TObject);
var
 Buffer: PTokenGroups;
 Token: THandle;
 HaveToken: Boolean;
 StringSid: PChar;
 curUser, curDomain:String;
 S, S2:String;

begin
isAdmin:=false;
S:='<font face="Lucida Console" size="9" color="red"><b>Benutzer-Info</b></font><br>';
S:=S+ '<font face="Lucida Console" size="9" color="black">' +GetCurrentUserAndDomain + '</font><br>';
S2:=GetGroups;
If IsAdmin=True Then
S:=S+'<font face="Lucida Console" size="9" color="black">Der Benutzer hat administrative Rechte</font><br> <br>'
Else
S:=S+'<font face="Lucida Console" size="9" color="black">Der Benutzer hat <b>keine</b> administrative Rechte</font><br> <br>';
S:=S+ '<font face="Lucida Console" size="9" color="red"><b>Gruppen</b></font><br>';
S:=S+'<font face="Lucida Console" size="9" color="black">' + S2 +'</font><br> <br>';
//S:=S+'<font face="Lucida Console" size="9" color="black">' + GetGroups +'</font><br> <br>';
S:=S+'<font face="Lucida Console" size="9" color="red"><b>Privilegien</b></font><br>';
S:=S+'<font face="Lucida Console" size="9" color="black">' + EnumPriv + '</font><br> <br> <br>';
S:=S+'<font face="Lucida Console" size="9" color="black">pcwPrivilegien: Infos/Download unter http://wwww.pcwelt.de</font><br> <br> <br>';
janMarkupViewer1.Text:=S;


end;

end.
