{

    Dieses Programm ist freie Software. Sie knnen es unter
    den Bedingungen der GNU General Public License, wie von der
    Free Software Foundation herausgegeben, weitergeben und/oder
    modifizieren, entweder unter Version 2 der Lizenz oder (wenn
    Sie es wnschen) jeder spteren Version

Autor: Thorsten Eggeling
Firma: IDG Magazine GmbH
Email: prx@pcwelt.de
Datum: 09/2005
Version: 2.0.0

Infos: compiliert mit Borland Delphi 7

Zustzliche Freeware/GPL-Komponenten:
Jedi (http://www.delphi-jedi.org)
DCPcrypt (http://www.cityinthesky.co.uk/cryptography.html)

}

program pcwRunAs;
{$APPTYPE CONSOLE}
uses
  SysUtils, Windows,JclBase,
  DCPblowfish,DCPsha1,Classes,JclStrings,DCPripemd160,JclFileUtils, JclSysInfo;

//thanks to http://www.cpcug.org/user/clemenzi/technical/Languages/Delphi/Parse.html
function Mid_mc(s:string; StartPos: integer; EndPos: integer = -1):string;
// NumOfCharacters = -1 means "to the end of the string"
var i, j: integer;
begin i := StartPos;
if (i < 1) then i := 1; if (i > length(s)) then begin Mid_mc := '';
exit;
end;
if EndPos < 0 then j := length(s)
 else
 j := EndPos;
 Mid_mc := copy(s, i, j-i+1);
 end; // Mid_mc integer, integer
/////////////////////
function InStr_mc(S, Pattern: string; Start: integer=1; CaseSensitive:boolean=false):integer;
 var tempStr: string;
 i, j: integer;
 begin
 i := Start;
 if (i < 1) then i := 1;
 if (i > length(s)) then
   begin InStr_mc := 0;
   exit;
   end;
   tempStr := copy(s, i, length(s));
   if CaseSensitive then j := pos(Pattern, tempStr)
    else
   j := pos(upperCase(Pattern), upperCase(tempStr));
   if J<>0 then j := i+j-1 ;
   InStr_mc := j;
   end; // InStr_mc
 //////////////////////////
function ParseString_mc(s: string; delimiters: string = ' ') : TStringList;
var
 tempStr, token: string;
 list: TStringList;
 i,j: integer;
 begin
 tempStr := s;
 list:= TStringList.Create;
 i:=1; if length(s)>0 then
 repeat while InStr_mc(delimiters, tempStr[i]) <> 0 do
 begin i := i+1;
 if i > length(s) then break;
 end;
 j:= i;
 if j <= length(s) then
  while InStr_mc(delimiters, tempStr[j]) = 0 do
   begin
    j := j+1;
    if j > length(s) then break;
    end;
    if i <= length(s) then
     begin
      token:=mid_mc(tempStr, i, j-1);
       list.Append(Trim(token));
       end;
       i := j+1;
       until i >= length(s) ;
       ParseString_mc := list;
end; // ParseString_mc
/////////////////////////////

function GetSerial: String;
begin
Result:='';
Result:=GetVolumeSerialNumber(StrLeft(ParamStr(0),2));

end;
///////////////////////////////////
function CreateHash(filename:string): String;
  var
    Hash: TDCP_ripemd160;
    Digest: array[0..19] of byte;  // RipeMD-160 produces a 160bit digest (20bytes)
    Source: TFileStream;
    i: integer;
    s: string;
    myAppPath:string;
begin
Source:= nil;
 //myAppPath:=PathExtractFileDirFixed( ParamStr(0));
 myAppPath:=filename;
 writeln('Debug: ' + myAppPath);


    try
      Source:= TFileStream.Create(myAppPath,fmOpenRead);  // open the file specified by Edit1
    except
      WriteLn('Fehler:Kann ' + myAppPath + ' nicht finden.');
    end;
    if Source <> nil then
    begin
      Hash:= TDCP_ripemd160.Create(nil);          // create the hash
      Hash.Init;                                   // initialize it
      Hash.UpdateStream(Source,Source.Size);       // hash the stream contents
      Hash.Final(Digest);                          // produce the digest
      Source.Free;
      s:= '';
      for i:= 0 to 19 do
        s:= s + IntToHex(Digest[i],2);
      Result:= s;                              // display the digest
    end;
end;

function CreateProcessWithLogonW(
  lpUsername,                 // user's name
  lpDomain,                   // user's domain
  lpPassword:PWideChar;       // user's password
  dwLogonFlags:dword;         // logon option
  lpApplicationName: PWideChar;
  lpCommandLine: PWideChar;
  dwCreationFlags: DWORD;
  lpEnvironment: Pointer;
  lpCurrentDirectory: PWideChar;
  const lpStartupInfo: tSTARTUPINFO;
  var lpProcessInformation: TProcessInformation
  ): BOOL; stdcall;external  'advapi32.dll';


Procedure ShowHelp();
begin
Writeln('');
Writeln('    pcwRunAs v0.2 by te prx@pcwelt.de');
Writeln('');
Writeln('    Usage: pcwRunAs [/?] [/d] [/noprofile] /u name /p password');
Writeln('                    [/dir] [/app <app>]|[/cmd <cmd>]');
Writeln('                    oder [/e Zeichenfolge]');
Writeln('');
Writeln('    /d         Domain');
Writeln('    /u         Benutzername');
Writeln('    /p         Kennwort');
Writeln('    /noprofile Benutzerprofil nicht verwenden');
Writeln('    /app       Anwendungsname');
Writeln('    /cmd       Kommandozeile');
Writeln('    /dir       Arbeitsverzeichnis');
Writeln('    /e         verschluesselte Zeichenfolge (zus. mit /cmd)');
Writeln('    /?         Zeigt diese Hilfe');
Writeln('');
Writeln('    Beispiele: pcwRunAs /u hugo /p geheim /cmd notepad.exe');
Writeln('               pcwRunAs /u hugo /p geheim /cmd "notepad.exe C:\neu.txt"');
Writeln(' ');
Writeln(' ');
Writeln('');
end;
  
function RunAsUser(const Domain, Username, Password, App, myCommand, strDir: string; intProfile:Integer):Integer;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  wDomain, wUsername, wPassword, wApp, wCommand, wDir: PWideChar;
  textxx:String;
begin
  try
  FillChar(StartupInfo, SizeOf(StartupInfo), #0);
  StartupInfo.cb := SizeOf(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := SW_SHOWNORMAL;
   textxx:='notepad.exe';

  GetMem(
    wDomain,
    Length(Domain) * SizeOf(WideChar) + SizeOf(WideChar));
  GetMem(
    wUsername,
    Length(Username) * SizeOf(WideChar) + SizeOf(WideChar));
  GetMem(
    wPassword,
    Length(Password) * SizeOf(WideChar) + SizeOf(WideChar));
  GetMem(
    wCommand,
    Length(myCommand) * SizeOf(WideChar) + SizeOf(WideChar));
  GetMem(
    wApp,
    Length(App) * SizeOf(WideChar) + SizeOf(WideChar));

  GetMem(
    wDir,
    Length(strDir) * SizeOf(WideChar) + SizeOf(WideChar));

  StringToWideChar(
    Domain,
    wDomain,
    Length(Domain) * SizeOf(WideChar) + SizeOf(WideChar));
  StringToWideChar(
    Username,
    wUsername,
    Length(Username) * SizeOf(WideChar) + SizeOf(WideChar));
  StringToWideChar(
    Password,
    wPassword,
    Length(Password) * SizeOf(WideChar) + SizeOf(WideChar));

  StringToWideChar(
    myCommand,
    wCommand,
    Length(myCommand) * SizeOf(WideChar) + SizeOf(WideChar));

  StringToWideChar(
    strDir,
    wDir,
    Length(strDir) * SizeOf(WideChar) + SizeOf(WideChar));

  StringToWideChar(
    App,
    wApp,
    Length(App) * SizeOf(WideChar) + SizeOf(WideChar));
    If strDir='' then wDir:=nil;
    If App='' Then wApp:=nil;

  if not CreateProcessWithLogonW(
    wUsername,
    wDomain,
    wPassword,
    intProfile,   //logon option
    wApp,         //app
    wCommand,     //cmdline
    0,            //creation flags
    nil,          //env
    wDir,          //CurDir
    StartupInfo,
    ProcessInfo) then RaiseLastOSError;
    Result:=0;
  Except
  on E: Exception do
  begin
  Writeln(E.Message);
  Result:=1;
  end;
  end;
  FreeMem(wDomain);
  FreeMem(wUsername);
  FreeMem(wPassword);
  FreeMem(wCommand);
  FreeMem(wApp);
end;


var
i: Integer;
strUsername:string;
strPassword: string;
strCmd: string;
strDom: string;
strApp : String;
strDir: String;
strSecret: string;
 KeyStr: string;
LOGON_WITH_PROFILE:Dword=1;
LOGON_NETCREDENTIALS_ONLY:Dword=2;
intProfile:integer=1;
Cipher: TDCP_blowfish;
myParamList:TStrings;    //encrypttion
myParamList2:TStrings;   // command line
encString:String;
boolUseEnc:Boolean;

Procedure ParseCMD (ParamList:TStrings);
begin
for i := 0 to ParamCount do
begin
 if LowerCase(ParamStr(i)) = '/u' Then
   begin
   strUsername:=ParamStr(i+1);
   end;

 if LowerCase(ParamStr(i)) = '/p' Then
   begin
   strPassword:=ParamStr(i+1);
   end;

 if LowerCase(ParamStr(i)) = '/cmd' Then
   begin
   strCmd:=ParamStr(i+1);

   end;

 if LowerCase(ParamStr(i)) = '/app' Then
   begin
   strApp:=ParamStr(i+1);
   end;

 if LowerCase(ParamStr(i)) = '/d' Then
   begin
   strDom:=ParamStr(i+1);
   end;

 if LowerCase(ParamStr(i)) = '/dir' Then
   begin
   strDir:=ParamStr(i+1);
   end;

   if LowerCase(ParamStr(i)) = '/noprofile' Then
   begin
   intProfile:=0;
   end;
end; //for j
end;
///////////////////////////////////////////
Procedure ParseCMD2 (ParamList:TStrings);
begin
for i := 0 to ParamList.Count -1 do
begin
 if LowerCase(ParamList[i]) = '/u' Then
   begin
   strUsername:=ParamList[i+1];
   end;

 if LowerCase(ParamList[i]) = '/p' Then
   begin
   strPassword:=ParamList[i+1];
   end;

 if LowerCase(ParamList[i]) = '/cmd' Then
   begin
   strCmd:=ParamList[i+1];
   end;

 if LowerCase(ParamList[i]) = '/app' Then
   begin
   strApp:=ParamList[i+1];
   end;

 if LowerCase(ParamList[i]) = '/d' Then
   begin
   strDom:=ParamList[i+1];
   end;

 if LowerCase(ParamList[i]) = '/dir' Then
   begin
   strDir:=ParamList[i+1];
   end;

   if LowerCase(ParamList[i]) = '/noprofile' Then
   begin
   intProfile:=0;
   end;
end; //for j
end;

begin
boolUseEnc:=False;

If ParamCount  < 1 Then
ShowHelp
Else
begin

myParamList2:=TStringList.Create;
myParamList:=TStringList.Create;
try
for i := 0 to ParamCount    do
   myParamList2.Add(ParamStr(i+1));
//read cmd
for i := 0 to myParamList2.Count-1 do
begin
 if LowerCase(ParamStr(i)) = '/cmd' Then
   begin
   strCmd:=ParamStr(i+1);
   end;
end;

//chk enc
for i := 0 to myParamList2.Count-1 do
begin
 if LowerCase(myParamList2[i]) = '/?' then
   begin
   ShowHelp;
   ExitCode:=2;
   Exit;
   end;
 //enc
 if LowerCase(myParamList2[i]) = '/e' then
  begin
  boolUseEnc:=True;
  strSecret:=myParamList2[i+1];

  If strCmd='' Then
    begin
     WriteLn('Fehler: Kein Kommando angegeben. Abbruch.');
     exit;
    end;

  KeyStr:= CreateHash(strCmd) + GetSerial;
  Cipher:= TDCP_blowfish.Create(nil);
  Cipher.InitStr(KeyStr,TDCP_sha1);
  encString:=Cipher.DecryptString(strSecret);

  Cipher.Burn;
  Cipher.Free;
   myParamList:=ParseString_mc(encString,';');
 end;



end; //for i

//unenc operation
If boolUseEnc Then
ParseCMD2(myParamList) //use enc
Else
ParseCMD2(myParamList2);


If (strCmd = '') And (strApp= '') Then
begin
Writeln('Fehler: Sie muessen ein Programm fuer /app oder /cmd angeben.' );
Exit;
end;

If strUsername = '' Then
Writeln('Fehler: Kein Benutzername angegeben.' );

If strPassword = '' Then
Writeln('Fehler: Kein Kennwort angegeben.' );
WriteLn(strDom,strUsername,strPassword,strApp,strCmd,strDir,intProfile);

ExitCode:=RunAsUSer(strDom,strUsername,strPassword,strApp,strCmd,strDir,intProfile);
 finally;
 myParamList2.Free;
 myParamList.Free;
 end;

 end;

end.