{

    Dieses Programm ist freie Software. Sie knnen es unter
    den Bedingungen der GNU General Public License, wie von der
    Free Software Foundation herausgegeben, weitergeben und/oder
    modifizieren, entweder unter Version 2 der Lizenz oder (wenn
    Sie es wnschen) jeder spteren Version

Autor: Thorsten Eggeling
Firma: IDG Magazine GmbH
Email: prx@pcwelt.de
Datum: 09/2005
Version: 1.1.0

Infos: compiliert mit Borland Delphi 7

Zustzliche Freeware/GPL-Komponenten:
Jedi (http://www.delphi-jedi.org)
DCPcrypt (http://www.cityinthesky.co.uk/cryptography.html)
}

unit untMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DCPcrypt2, DCPblockciphers, DCPblowfish, DCPsha1,
  Mask, JvExMask, JvToolEdit,ShlObj, ActiveX, ComObj,JclSysInfo,DCPripemd160,JclFileUtils,
  ExtCtrls, JclStrings;

type
  TForm1 = class(TForm)
    DCP_blowfish1: TDCP_blowfish;
    OK: TButton;
    DCP_sha11: TDCP_sha1;
    btnDec: TButton;
    GroupBox1: TGroupBox;
    edtIn: TEdit;
    JvFilenameEdit1: TJvFilenameEdit;
    Label1: TLabel;
    edtUser: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    edtPassword: TEdit;
    Label4: TLabel;
    edtParam: TEdit;
    Label5: TLabel;
    edtWorkDir: TEdit;
    chkDomain: TCheckBox;
    chkProfile: TCheckBox;
    btnEnc: TButton;
    btnShortcut: TButton;
    btnHash: TButton;
    Label6: TLabel;
    Label7: TLabel;
    lblKey: TLabel;
    edtLinkName: TEdit;
    Label8: TLabel;
    edtOut: TEdit;
    procedure OKClick(Sender: TObject);
    procedure btnDecClick(Sender: TObject);
    procedure btnEncClick(Sender: TObject);
    procedure btnShortcutClick(Sender: TObject);
    procedure btnHashClick(Sender: TObject);
    function CreateHash:String;
    function GetSerial:String;
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure CreateShortcut(TargetName,LinkName, Desc, Param:String);
var
  IObject    : IUnknown;
  ISLink     : IShellLink;
  IPFile     : IPersistFile;

begin
  IObject := CreateComObject(CLSID_ShellLink);
  ISLink  := IObject as IShellLink;
  IPFile  := IObject as IPersistFile;

  with ISLink do begin
     SetArguments(PChar(Param));
     SetDescription(PChar(Desc));
     SetPath(pChar(TargetName));
     SetWorkingDirectory
	   (pChar(ExtractFilePath(TargetName)));
     SetShowCmd(SW_SHOWMINIMIZED);
     SetIconLocation(PChar(Form1.JvFilenameEdit1.Text),0);
  end;
  IPFile.Save(PWChar(WideString(LinkName)), False);


end;
procedure CreateShortCut2(ShortCut, Application, Parameters, WorkDir:
string; SW_State: Integer; IconFile: string; IconIndex: Byte);
var
  SCObject: IUnknown;
  SCSLink: IShellLink;
  SCPFile: IPersistFile;
  WFName: WideString;
begin
  SCObject := CreateComObject(CLSID_ShellLink);
  SCSLink := SCObject as IShellLink;
  SCPFile := SCObject as IPersistFile;
  SCSLink.SetPath(PChar(Application));
  SCSLink.SetArguments(PChar(Parameters));
  SCSLink.SetWorkingDirectory(PChar(WorkDir));
  SCSLink.SetShowCmd(SW_State);
  SCSLink.SetIconLocation(PChar(IconFile), IconIndex);
  WFName := ShortCut;
  SCPFile.Save(PWChar(WFName), False);
end;

procedure TForm1.btnShortcutClick(Sender: TObject);
var
myAppPath:String;
begin
myAppPath:=PathExtractFileDirFixed( Application.ExeName);
myAppPath:=myAppPath + 'pcwRunAs.exe';
If Not FileExists(myAppPath) Then
begin
Application.MessageBox(
        'pcwRunAs.Exe nicht gefunden. Die Datei muss sich im gleichen Verzeichnis befinden wie pcwRunAs2.exe.',
        'Fehler',
        MB_OK);
exit;
end;

If edtLinkName.Text='' Then
begin
Application.MessageBox(
        'Sie mssen hinter "Verknpfung" einen Namen fr den Shortcut eingeben.',
        'Fehler',
        MB_OK);
Exit;
End;

If lblKey.Caption='' Then
begin
Application.MessageBox(
        'Klicken Sie zuerst auf "bernehmen", um einen Schlssel zu erzeugen.',
        'Fehler',
        MB_OK);
Exit;
End;
CreateShortCut(myAppPath,GetDesktopFolder + '\' +
 edtLinkName.Text +
  '.lnk', edtLinkName.Text, ' /cmd ' + StrDoubleQuote(JvFilenameEdit1.Text) + ' /e ' + lblKey.Caption);
end;


procedure TForm1.OKClick(Sender: TObject);
var
  myString,myString2 :String;
  KeyStr: string;
begin
myString:='';
If chkDomain.Checked Then myString:='/d;';
If chkProfile.Checked Then myString:=myString + '/noprofile;';
myString:=myString + '/u;' + edtUser.text + ';/p;' + edtPassword.Text +';';
if edtWorkDir.Text<>'' Then myString:= myString + '/dir;' + edtWorkDir.Text +';';
myString:= myString + '/cmd;' + JvFilenameEdit1.Text + ' ' + edtParam.Text;
edtIn.text:= myString;
//enc
KeyStr:= '';
KeyStr:= CreateHash + GetSerial;
DCP_blowfish1.InitStr(KeyStr,TDCP_sha1);
lblKey.Caption:=DCP_blowfish1.EncryptString(edtIn.Text);
DCP_blowfish1.Burn;


end;

//Entschluesseln
procedure TForm1.btnDecClick(Sender: TObject);
var
    KeyStr: string;
begin
KeyStr:= '';
KeyStr:= CreateHash + GetSerial;
DCP_blowfish1.InitStr(KeyStr,TDCP_sha1);
edtIn.Text:=DCP_blowfish1.DecryptString(edtOut.Text);
end;

//enc
procedure TForm1.btnEncClick(Sender: TObject);
var
    KeyStr: string;
begin
KeyStr:= '';
KeyStr:= CreateHash + GetSerial;
DCP_blowfish1.InitStr(KeyStr,TDCP_sha1);
edtOut.Text:=DCP_blowfish1.EncryptString(edtIn.Text);
DCP_blowfish1.Burn;

end;



procedure TForm1.btnHashClick(Sender: TObject);

begin
GetSerial;
end;

function TForm1.CreateHash: String;
  var
    Hash: TDCP_ripemd160;
    Digest: array[0..19] of byte;  // RipeMD-160 produces a 160bit digest (20bytes)
    Source: TFileStream;
    i: integer;
    s: string;
    myAppPath:string;
begin
Source:= nil;
If FileExists(JvFilenameEdit1.Text) Then
 begin
  myAppPath:=PathExtractFileDirFixed(JvFilenameEdit1.Text);
    try
      Source:= TFileStream.Create(JvFilenameEdit1.Text,fmOpenRead);  // open the file specified by Edit1
    except
      MessageDlg('Kann ' + JvFilenameEdit1.Text + 'nicht finden.',mtError,[mbOK],0);
    end;
    if Source <> nil then
    begin
      Hash:= TDCP_ripemd160.Create(Self);          // create the hash
      Hash.Init;                                   // initialize it
      Hash.UpdateStream(Source,Source.Size);       // hash the stream contents
      Hash.Final(Digest);                          // produce the digest
      Source.Free;
      s:= '';
      for i:= 0 to 19 do
        s:= s + IntToHex(Digest[i],2);
      Result:= s;                              // display the digest
    end;
end
Else
MessageDlg('Kann ' + JvFilenameEdit1.Text + 'nicht finden.',mtError,[mbOK],0);
end;

function TForm1.GetSerial: String;

begin
Result:=GetVolumeSerialNumber(StrLeft(Application.ExeName,2));
end;

procedure TForm1.FormShow(Sender: TObject);
begin
JvFilenameEdit1.SetFocus;
end;

end.

